/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for provenance information.
    /// </summary>
    [DataContract(Name = "ProvenanceDto")]
    public partial class ProvenanceDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProvenanceDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProvenanceDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProvenanceDto" /> class.
        /// </summary>
        /// <param name="id">Gets or sets the id of the current metadata graph. (required).</param>
        /// <param name="generatedAt">Gets or sets the date and time when the metadata was generated..</param>
        /// <param name="wasRevisionOf">Gets or sets the adapted versions from the specific metadata tree. (required).</param>
        /// <param name="variants">Gets or sets the variants of the specific metadata tree. (required).</param>
        /// <param name="similarityToLastVersion">The similarity to the last version..</param>
        /// <param name="wasInvalidatedBy">Information if the specific metadata tree was invalidated by something..</param>
        /// <param name="hashParameters">hashParameters.</param>
        public ProvenanceDto(string id = default(string), DateTime? generatedAt = default(DateTime?), List<string> wasRevisionOf = default(List<string>), List<VariantDto> variants = default(List<VariantDto>), double? similarityToLastVersion = default(double?), string wasInvalidatedBy = default(string), HashParametersDto hashParameters = default(HashParametersDto))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new ArgumentNullException("id is a required property for ProvenanceDto and cannot be null");
            }
            this.Id = id;
            // to ensure "wasRevisionOf" is required (not null)
            if (wasRevisionOf == null)
            {
                throw new ArgumentNullException("wasRevisionOf is a required property for ProvenanceDto and cannot be null");
            }
            this.WasRevisionOf = wasRevisionOf;
            // to ensure "variants" is required (not null)
            if (variants == null)
            {
                throw new ArgumentNullException("variants is a required property for ProvenanceDto and cannot be null");
            }
            this.Variants = variants;
            this.GeneratedAt = generatedAt;
            this.SimilarityToLastVersion = similarityToLastVersion;
            this.WasInvalidatedBy = wasInvalidatedBy;
            this.HashParameters = hashParameters;
        }

        /// <summary>
        /// Gets or sets the id of the current metadata graph.
        /// </summary>
        /// <value>Gets or sets the id of the current metadata graph.</value>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the date and time when the metadata was generated.
        /// </summary>
        /// <value>Gets or sets the date and time when the metadata was generated.</value>
        [DataMember(Name = "generatedAt", EmitDefaultValue = true)]
        public DateTime? GeneratedAt { get; set; }

        /// <summary>
        /// Gets or sets the adapted versions from the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the adapted versions from the specific metadata tree.</value>
        [DataMember(Name = "wasRevisionOf", IsRequired = true, EmitDefaultValue = true)]
        public List<string> WasRevisionOf { get; set; }

        /// <summary>
        /// Gets or sets the variants of the specific metadata tree.
        /// </summary>
        /// <value>Gets or sets the variants of the specific metadata tree.</value>
        [DataMember(Name = "variants", IsRequired = true, EmitDefaultValue = true)]
        public List<VariantDto> Variants { get; set; }

        /// <summary>
        /// The similarity to the last version.
        /// </summary>
        /// <value>The similarity to the last version.</value>
        [DataMember(Name = "similarityToLastVersion", EmitDefaultValue = true)]
        public double? SimilarityToLastVersion { get; set; }

        /// <summary>
        /// Information if the specific metadata tree was invalidated by something.
        /// </summary>
        /// <value>Information if the specific metadata tree was invalidated by something.</value>
        [DataMember(Name = "wasInvalidatedBy", EmitDefaultValue = true)]
        public string WasInvalidatedBy { get; set; }

        /// <summary>
        /// Gets or Sets HashParameters
        /// </summary>
        [DataMember(Name = "hashParameters", EmitDefaultValue = false)]
        public HashParametersDto HashParameters { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProvenanceDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  WasRevisionOf: ").Append(WasRevisionOf).Append("\n");
            sb.Append("  Variants: ").Append(Variants).Append("\n");
            sb.Append("  SimilarityToLastVersion: ").Append(SimilarityToLastVersion).Append("\n");
            sb.Append("  WasInvalidatedBy: ").Append(WasInvalidatedBy).Append("\n");
            sb.Append("  HashParameters: ").Append(HashParameters).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
